import javax.microedition.lcdui.*;

public class UrlForm extends Form implements CommandListener { 
    MapBrowser browser;
    TextField  url;

    static final int MAX_URL_LENGTH = 256;

    UrlForm(MapBrowser browser) { 
        super(Locale.current.getResource("Load Map"));
        this.browser = browser;
        addCommand(MapBrowser.LOAD_CMD);
        addCommand(MapBrowser.QUIT_CMD);
        url = new TextField(Locale.current.getResource("URL"), browser.url, MAX_URL_LENGTH, TextField.URL);
        append(url);
        setCommandListener(this);
        Display.getDisplay(browser).setCurrent(this);
    }

    public void commandAction(Command c, Displayable d) 
    {
        if (c == MapBrowser.LOAD_CMD) { 
            String address = url.getString().trim();
            if (address.length() == 0) { 
                return;
            }
            if (!address.startsWith("http://")) { 
                address = "http://" + address;
            }
            browser.url = address;
            setTicker(new Ticker(Locale.current.getResource("Connecting to") + ' ' + address.substring(7)));
            new InternetConnection(address + "index.xml", browser);
        } else { 
            browser.quit();
        }
    }
}


